local function GetGravMul(mo)
	if mo.eflags & MFE_VERTICALFLIP then return -1 end
	return 1
end

-- Melee
addHook("SpinSpecial", function(p)
	if p.charability2 ~= CA2_MELEE then return end
	if p.charability ~= CA_TWINSPIN then return end
	if not P_IsObjectOnGround(p.mo) then return end
	if p.speed < 15*p.mo.scale then return end
	if p.urmom.groundtwincooldown then
		return true
	end
	if p.pflags & PF_SPINDOWN then return end
	p.urmom.groundtwincooldown = 30
	p.urmom.groundtwin = 10
	return true
end)

addHook("PlayerThink", function(p)
	if p.charability2 ~= CA2_MELEE then return end
	if p.urmom.groundtwincooldown then
		p.urmom.groundtwincooldown = $ - 1
	end
	if not p.urmom.groundtwin then return end
	if (p.urmom.groundtwin == 10) then
		S_StartSound(p.mo, sfx_s3k42)
		p.mo.state = S_PLAY_TWINSPIN
		p.pflags = $ | PF_SPINNING
		p.mo.momx = $/4*3
		p.mo.momy = $/4*3
	end
	p.pflags = p.pflags | PF_JUMPSTASIS
	p.urmom.groundtwin = $ - 1
	if p.urmom.groundtwin == 1 then
		p.pflags = $ & ~PF_SPINNING
		if p.cmd.buttons & BT_USE then
			p.mo.state = S_PLAY_ROLL
			p.mo.momz = p.mo.momz + (GetGravMul(p.mo) * (p.speed / 3))
			p.pflags = ($ & ~PF_THOKKED) | PF_JUMPED
			p.urmom.afterimage = 10
			p.mo.momx = $*2
			p.mo.momy = $*2
			S_StartSound(mo, sfx_s3k5d)
			P_Earthquake(p.mo, p.mo, 100*FRACUNIT)
		else
			p.mo.momx = $/3*5
			p.mo.momy = $/3*5
		end
	end
	if p.urmom.groundtwin == 0 then
		if p.cmd.buttons & BT_USE and not (p.pflags & PF_SPINDOWN) then
			p.pflags = ($ & ~PF_THOKKED) | PF_JUMPED
			p.mo.state = S_PLAY_ROLL
		end
	end
end)

addHook("MobjDamage", function(mo, inf, src, dmg, type)
	local p = mo.player
	
	-- If the player does not have the twinspin ability, use the default behavior
	if p.charability ~= CA_TWINSPIN then return end
	
	-- If the player isn't in the twinspin state, also use the defualt behavior
	if p.mo.state ~= S_PLAY_TWINSPIN then return end
	
	-- You can't protect yourself from an instakill
	-- That would be too op anyways
	if type & DMG_DEATHMASK then return end
	
	-- If the inflictor is a projectile
	if inf and inf.valid and inf.flags & MF_MISSILE then
		-- It's now the player's projectile
		inf.target = mo
		local proj = P_SpawnMobj(inf.x, inf.y, inf.z, inf.type)
		proj.scale = inf.scale
		proj.target = mo
		
		if src and src.valid then
			local angle = R_PointToAngle2(inf.x, inf.y, src.x, src.y)
			proj.angle = angle
			
			local h = max(abs(src.x - inf.x), abs(src.y - inf.y), abs(src.z - inf.z))
			if h <= 0 then
				proj.momx = -inf.momx
				proj.momy = -inf.momy
				proj.momz = -inf.momz
				proj.angle = InvAngle(inf.angle)
			else
				local spd = abs(inf.momx) + abs(inf.momy) + abs(inf.momz) + 5*FRACUNIT
				
				proj.momx = FixedMul(FixedDiv(src.x - inf.x, h), spd)
				proj.momy = FixedMul(FixedDiv(src.y - inf.y, h), spd)
				proj.momz = FixedMul(FixedDiv(src.z - inf.z, h), spd)
				proj.flags = $ | MF_NOGRAVITY
			end
		else
			-- Invert the projectile's direction
			proj.momx = -inf.momx
			proj.momy = -inf.momy
			proj.momz = -inf.momz
			proj.angle = InvAngle(inf.angle)
		end
		inf.state = inf.info.deathstate
	end
	local g = P_SpawnGhostMobj(p.mo)
	g.scale = g.scale + (g.scale/3)
	g.blendmode = AST_ADD
	p.powers[pw_flashing] = 7
	local thok = UM_SpawnThok(p)
	thok.color = SKINCOLOR_WHITE
	thok.frame = $ & ~FF_PAPERSPRITE
	return true
end, MT_PLAYER)
local function Sign(num)
	if num > 0 then return 1 end
	if num < 0 then return -1 end
	return 0
end

-- me when i realize there is already an amy mod with this same ability
addHook("MobjMoveBlocked", function(mo)
	local p = mo.player
	if p.charability ~= CA_TWINSPIN then return end
	if p.mo.state ~= S_PLAY_TWINSPIN then return end
	if not (p.pflags & PF_JUMPED) then 
		if P_IsObjectOnGround(p.mo) then
			local gravmul = 1
			if p.mo.eflags & MFE_VERTICALFLIP then
				gravmul = -1
			end
			S_StartSound(mo, sfx_s3k8b)
			S_StartSound(mo, sfx_s3k5d)
			P_BounceMove(p.mo)
			p.mo.momx = p.mo.momx/8*5
			p.mo.momy = p.mo.momy/8*5
			p.mo.momz = (p.speed/8*3) * gravmul
			p.drawangle = R_PointToAngle2(p.mo.x, p.mo.y, p.mo.x + p.mo.momx, p.mo.y + p.mo.momy)
			p.pflags = ($ | PF_JUMPED) & ~PF_THOKKED
			p.mo.state = S_PLAY_JUMP
			p.urmom.afterimage = 10
			P_Earthquake(p.mo, p.mo, 100*FRACUNIT)
		end
		return
	end
	if (abs(mo.momx) + abs(mo.momy)) < 1*mo.scale then return end
	S_StartSound(mo, sfx_s3k8b)
	P_BounceMove(mo)
	local magnitude = FixedSqrt(FixedMul(mo.momx, mo.momx) + FixedMul(mo.momy, mo.momy))
	mo.momx = FixedMul(FixedDiv(mo.momx, magnitude), 15*mo.scale)
	mo.momy = FixedMul(FixedDiv(mo.momy, magnitude), 15*mo.scale)
	S_StartSound(mo, sfx_s3k5d)
	local g = P_SpawnGhostMobj(p.mo)
	g.scale = g.scale + (g.scale/3)
	g.blendmode = AST_ADD
	--p.powers[pw_flashing] = 7
	P_Earthquake(mo, mo, 100*FRACUNIT)
	p.drawangle = InvAngle(p.drawangle)
	if mo.eflags & MFE_VERTICALFLIP then
		mo.momz = -20*mo.scale
	else
		mo.momz = 20*mo.scale
	end
	p.urmom.afterimage = 10
	p.pflags = $ & ~PF_JUMPED
end, MT_PLAYER)
