rawset(_G, "bounce", true)
COM_AddCommand("um_bounce", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		bounce = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		bounce = false
	else
		CONS_Printf(p, "um_bounce [on/off] - Toggles whether or not you can bounce off of walls after thokking. Currently "
		+ (bounce and "enabled") or (not bounce and "disabled"))
	end
end, COM_ADMIN)

addHook("PlayerThink", function(p)
	if not p.mo then return end
	if p.charability == CA_THOK then
		-- Spawn a trail to indicate that the player can no longer thok
		-- And also because i like abusing additive blended afterimages lol
		-- TODO: Maybe differentiate this with the >normalspeed effect more?
		if p.pflags & PF_THOKKED and leveltime % 2 == 0 and not P_IsObjectOnGround(p.mo) then
			local g = P_SpawnGhostMobj(p.mo)
			g.blendmode = AST_ADD
			g.colorized = true
		end
	end
end)
addHook("AbilitySpecial", function(p)
	if p.charability == CA_THOK then
		if p.pflags & PF_THOKKED then return end
		p.mo.state = S_PLAY_JUMP
		local f = p.actionspd / 2
		if p.speed < FixedMul(p.actionspd, p.mo.scale) then
			f = min(p.actionspd, FixedMul(p.actionspd, p.mo.scale) - p.speed)
		end
		f = (FixedMul(f, p.mo.scale) + (p.speed/16))/4*3
		P_InstaThrust(p.mo, p.mo.angle, (p.speed + abs(p.mo.momz/16)) + f)
		local dir = 4
		if p.cmd.buttons & BT_SPIN then 
			dir = -25
		end
		if dir < 0 then
			f = $*2
		end
		if p.mo.eflags & MFE_VERTICALFLIP then
			p.mo.momz = -dir*p.mo.scale
		else
			p.mo.momz = dir*p.mo.scale
		end
		S_StartSound(p.mo, sfx_thok)
		UM_SpawnThok(p)
		p.pflags = $ | PF_THOKKED
		p.urmom.lowgrav = 5
		return true
	end
end)
addHook("MobjDamage", function(mo, inf, src)
	if inf and inf.valid and inf.type == MT_PLAYER then
		if inf.player.charability == CA_THOK and inf.player.pflags & PF_THOKKED then
			-- Regain the ability to thok
			inf.player.pflags = $ & ~PF_THOKKED
			local g = P_SpawnGhostMobj(inf)
			g.scale = g.scale + (g.scale/3)
			g.blendmode = AST_ADD
			local force = 8
			if mo.health > 1 then
				force = 10
			end
			force = $ + ((FixedDiv(inf.player.speed, inf.scale)/32)/FRACUNIT)
			if inf.eflags & MFE_VERTICALFLIP then
				inf.momz = $ - (force*mo.scale)
			else
				inf.momz = $ + (force*mo.scale)
			end
		end
	end
end)

-- Totally not a rebound dash
addHook("MobjMoveBlocked", function(mo)
	local p = mo.player
	if p.charability2 == CA2_MELEE then return end
	local spin = p.pflags & PF_SPINNING
	local thok = (p.charability == CA_THOK) and (p.pflags & PF_THOKKED)
	local tripledash = p.mo.skin == "extralife" and p.tdashcount > 0
	if not bounce and thok then return end
	if not thok and not tripledash then return end
	if p.mo.state ~= S_PLAY_JUMP and p.mo.state ~= S_PLAY_ROLL then return end
	if p.speed < 10*mo.scale then return end

	P_BounceMove(mo)
	mo.momx = $/16*17
	mo.momy = $/16*17
	S_StartSound(mo, sfx_s3k5d)
	p.pflags = ($ | PF_JUMPED) & ~(PF_SPINNING|PF_THOKKED)
	p.mo.state = S_PLAY_JUMP
	if (p.urmom.thokbounce <= 0) then
		p.pflags = $ | PF_THOKKED
		p.mo.state = S_PLAY_FALL
	end
	
	if mo.eflags & MFE_VERTICALFLIP then
		mo.momz = -6*p.mo.scale * p.urmom.thokbounce
	else
		mo.momz = 6*p.mo.scale * p.urmom.thokbounce
	end
	p.urmom.thokbounce = $ - 1
	-- Holy shit!1 Extra Life support!!!!1!11
	if p.mo.skin == "extralife" then

		-- Allow Extra Life to do one more dash if he has run out of triple dashes
		if p.tdashcount >= 3 then
			p.tdashcount = 2
		end

		-- Ha ha yes
		p.urmom.afterimage = 10
		-- No more triple dash
		if p.urmom.thokbounce <= -1 then
			p.tdashcount = 3
		end
		-- Bounce counter depletes quicker
		-- p.urmom.thokbounce = $ - 1
		-- Except it doesn't
	end
	if p.powers[pw_super] then
		P_Earthquake(p.mo, p.mo, 125*FRACUNIT)
	end
end, MT_PLAYER)