addHook("PlayerThink", function(p)
	if p.charability ~= CA_FLY then return end
	if UM_SkinInfo(p.mo.skin).noflight then return end
	local flyspeedlimit = FixedMul(p.actionspd / 9, p.mo.scale)
	local flyspeed = flyspeedlimit/TICRATE*2
	
	if p.mo.eflags & MFE_UNDERWATER then
		flyspeed = $/4*3
		flyspeedlimit = $/4*3
	end
	local gravmul = 1
	if p.mo.eflags & MFE_VERTICALFLIP then gravmul = -1 end
	local flip = p.mo.eflags & MFE_VERTICALFLIP
	
	local atUpperLimit = (p.mo.momz >= flyspeedlimit and not flip) or (p.mo.momz <= -flyspeedlimit and flip)
	local atLowerLimit = (p.mo.momz >= flyspeedlimit and flip) or (p.mo.momz <= -flyspeedlimit and not flip)
	
	if p.mo.state == S_PLAY_FLY 
	or p.mo.state == S_PLAY_SWIM 
	or p.mo.state == S_PLAY_FLY_TIRED then
		if p.powers[pw_tailsfly] then
			if p.cmd.buttons & BT_JUMP then
				if p.speed > p.normalspeed/8*7 then
					p.mo.momx = $/1024*1012
					p.mo.momy = $/1024*1012
				elseif leveltime % 3 == 0
					p.powers[pw_tailsfly] = $ + 1
				end
				if not atUpperLimit then
					p.mo.momz = $ + flyspeed * gravmul
				end
			else
				if not atLowerLimit then
					p.mo.momz = ($ - flyspeed * gravmul)
				end
			end
		end
		if p.cmd.buttons & BT_USE then
			S_StartSound(p.mo, sfx_jump)
			p.mo.state = S_PLAY_JUMP
			p.pflags = ($ | PF_JUMPED) & ~PF_CANCARRY
			p.powers[pw_tailsfly] = 0
			p.mo.momz = gravmul * 7 * FixedMul(p.jumpfactor, p.mo.scale)
			
			local t = UM_SpawnThok(p)
			t.frame = ($ & ~FF_PAPERSPRITE)
			t.renderflags = t.renderflags | RF_FLOORSPRITE
		end
	end
end)