local recoveryJump = true
COM_AddCommand("um_recoveryjump", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		recoveryJump = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		recoveryJump = false
	else
		CONS_Printf(p, "um_recoveryjump [on/off] - Toggles whether or not the recovery jump can be used")
	end
end, COM_ADMIN)
addHook("NetVars", function(net)
	recoveryJump = net(recoveryJump)
end)
-- Recovery Jump/Coyote time
addHook("PlayerThink", function(p)
	if not p.mo then return end
	if not recoveryJump then return end
	if not p.urmom.jumptap then return end
	-- Shouldn't activate if the player is dead
	if p.mo.health <= 0 then return end
	-- Wouldn't want the recovery jump to activate in the ground, would you?
	if P_IsObjectOnGround(p.mo) then return end
	-- You should only be able to use the recovery jump while in a non-jump state
	if (p.pflags & PF_JUMPED) then return end
	-- Don't activate it immediately after getting hit, that would be overpowered
	if P_PlayerInPain(p) and p.urmom.paintime < TICRATE/3 then return end
	-- Have a small time window where you can perform a recovery jump after walking off of a playform or bouncing off of a spring
	if not P_PlayerInPain(p) and p.urmom.airtime > 8 then return end
	local isRecovery = P_PlayerInPain(p)
	if p.mo.state == S_PLAY_FLY or p.mo.state == S_PLAY_SWIM or p.mo.state == S_PLAY_FLY_TIRED then return end
	
	local g = P_SpawnGhostMobj(p.mo)
	g.scale = g.scale + (g.scale/3)
	g.blendmode = AST_ADD
	
	local t = UM_SpawnThok(p)
	t.frame = ($ & ~FF_PAPERSPRITE)
	t.renderflags = t.renderflags | RF_FLOORSPRITE
	
	if isRecovery then
		p.mo.momx = -p.mo.momx
		p.mo.momy = -p.mo.momy
	end
	
	-- Make the player jump
	P_DoJump(p, true)
	
	p.urmom.afterimage = 10
	
	-- Lower jump height
	if isRecovery then p.mo.momz = p.mo.momz - (p.mo.momz/4) end
	
end)