-- I see you have looked at this specific file
-- Your reward is uhhhhh
-- Jelly Mode "easter egg", i guess

local jellymode = true
local jellyjustchanged = true
local stronk = false
CV_RegisterVar({
    name = "jellysonicisreal2401",
    defaultValue = 0,
    flags = CV_NETVAR|CV_CALL|CV_NOSHOWHELP,
    func = function(cv)
        jellymode = string.lower(cv.string) == "on" or cv.string == "1"
        jellyjustchanged = true
    end
})
CV_RegisterVar({
    name = "umjm_stronk",
    defaultValue = 0,
    flags = CV_NETVAR|CV_CALL|CV_NOSHOWHELP,
    func = function(cv)
        stronk = string.lower(cv.string) == "on" or cv.string == "1"
    end
})
addHook("ThinkFrame", function()
    if not jellymode then return end
    for p in players.iterate() do
        if UM_SkinInfo(p.mo.skin).nojellymode then continue end
        local jelly = p.urmom.jelly
        if not P_IsObjectOnGround(p.mo) then
            jelly.fallspeed = p.mo.momz
        end
        local factor = min(max(abs(jelly.fallspeed)/64, -FRACUNIT/16*10), FRACUNIT/16*10)
        if P_IsObjectOnGround(p.mo) then
            local factor2 = min(max(factor/4*14, -FRACUNIT/16*10), FRACUNIT/16*10)
            jelly.scalex = FixedMul(jelly.scalex, FRACUNIT + factor2)
            jelly.scaley = FixedMul(jelly.scaley, FixedDiv(FRACUNIT, FRACUNIT + factor2))
            if abs(jelly.fallspeed) > 15*FRACUNIT then
                p.mo.momz = -jelly.fallspeed/8*4
                p.pflags = $ | PF_JUMPED
            end
            jelly.fallspeed = 0
        end
        if p.pflags & PF_STARTJUMP and p.urmom.airtime == 1 then
            jelly.scalex = FRACUNIT/2*3
            jelly.scaley = FRACUNIT/3*2
        end
        p.mo.spritexscale = FixedDiv(jelly.scalex, FRACUNIT + factor)
        p.mo.spriteyscale = FixedMul(jelly.scaley, FRACUNIT + factor)
        jelly.smomx = $ + (FRACUNIT - jelly.scalex)/TICRATE
        jelly.smomy = $ + (FRACUNIT - jelly.scaley)/TICRATE
        jelly.smomx = min(max(jelly.smomx, -FRACUNIT/4*3), FRACUNIT/4*3)
        jelly.smomy = min(max(jelly.smomy, -FRACUNIT/4*3), FRACUNIT/4*3)
        jelly.scalex = $ + jelly.smomx
        jelly.scaley = $ + jelly.smomy
        jelly.smomx = FixedMul(jelly.smomx, FRACUNIT - FRACUNIT/2048)
        jelly.smomy = FixedMul(jelly.smomy, FRACUNIT - FRACUNIT/2048)
        jelly.scalex = $ + max(min((FRACUNIT - jelly.scalex), FRACUNIT/48), -FRACUNIT/48)
        jelly.scaley = $ + max(min((FRACUNIT - jelly.scaley), FRACUNIT/48), -FRACUNIT/48)
        if jelly.nobounce then jelly.nobounce = $ - 1 end
    end
end)
addHook("PostThinkFrame", function()
    for p in players.iterate() do
        local jelly = p.urmom.jelly
        if jellymode and not UM_SkinInfo(p.mo.skin).nojellymode then
            p.mo.frame = $ | FF_TRANS30
            p.mo.colorized = true
            if jelly.bmomx or jelly.bmomy or jelly.bmomz then
                p.mo.momx = jelly.bmomx
                p.mo.momy = jelly.bmomy
                p.mo.momz = jelly.bmomz
                jelly.bmomx = 0
                jelly.bmomy = 0
                jelly.bmomz = 0
            end
        end
        if (not jellymode or UM_SkinInfo(p.mo.skin).nojellymode) and jellyjustchanged then
            p.mo.colorized = false
            p.mo.spritescalex = FRACUNIT
            p.mo.spritescaley = FRACUNIT
        end
        
    end
    jellyjustchanged = false
end)
addHook("MobjMoveBlocked", function(mo)
    local p = mo.player
    if not p then return end
    if not jellymode or UM_SkinInfo(p.mo.skin).nojellymode then return end
    local t = abs(mo.momx) + abs(mo.momy) + abs(mo.momz)
    if t < 5*FRACUNIT then return end
    p.urmom.jelly.bmomx = -mo.momx/4*3
    p.urmom.jelly.bmomy = -mo.momy/4*3
    p.urmom.jelly.bmomz = abs(mo.momz/8*9)
end, MT_PLAYER)
addHook("MobjMoveCollide", function(tmmo, mo)
    local p = tmmo.player
    if p.urmom.jelly.nobounce then return end
    if not jellymode or UM_SkinInfo(p.mo.skin).nojellymode then return end
    if (not (mo.flags & MF_ENEMY) and not (mo.flags & MF_MONITOR) and not (mo.type == MT_PLAYER) and not stronk)
    -- Rings are excluded, even when stronk is on
    or mo.type == MT_RING or mo.type == MT_FLINGRING or mo.type == MT_BLUESPHERE then return end 
    if mo.z < tmmo.z then return end
    if mo.z > tmmo.z + tmmo.height then return end
    local jelly = p.urmom.jelly
    local jelly2 = nil
    if mo.type == MT_PLAYER then jelly2 = mo.player.urmom.jelly end
    if jelly2 then 
        if jelly2.nobounce then return end
        jelly2.nobounce = 1
    end
    jelly.nobounce = 1
    jelly.bmomx = -tmmo.momx + mo.momx
    jelly.bmomy = -tmmo.momy + mo.momy
    jelly.bmomz = -tmmo.momz/4*3 + mo.momz
    mo.momx = -mo.momx + tmmo.momx
    mo.momy = -mo.momy + tmmo.momy
    mo.momz = -mo.momz/4*3 + tmmo.momz
end, MT_PLAYER)