-- Underscore at the start of the file name so that it's added first to the pk3
freeslot("sfx_vboom", "sfx_rethok")

sfxinfo[sfx_vboom].caption = "Vine Boom"
sfxinfo[sfx_rethok].caption = "Thok Reverb"

local airControl = true
local highGravity = true
local gravfactor = FRACUNIT/2*3
local aircontrolfactor = FRACUNIT*2
local speedincfactor = FRACUNIT/100*7
local maxspeedincfactor = FRACUNIT/100*150
local chaos = false
local speedlines = false
rawset(_G, "unfunny", false)

addHook("NetVars", function(net)
	airControl = net(airControl)
	highGravity = net(highGravity)
	gravfactor = net(gravfactor)
	aircontrolfactor = net(aircontrolfactor)
	speedincfactor = net(speedincfactor)
	maxspeedincfactor = net(maxspeedincfactor)
	bounce = net(bounce)
	chaos = net(chaos)
end)
local function UM_DefaultThrustFactor(p)
	local t = skins[p.mo.skin].thrustfactor
	if p.powers[pw_sneakers] or p.powers[pw_super] then t = (t*FRACUNIT/16*17)/FRACUNIT end
	return t
end
addHook("PreThinkFrame", function()
	for p in players.iterate() do
		if not p.urmom then continue end
		if not p.mo then continue end
		-- Originally a frame-perfect bug, but now it's a feature because it looked cool
		if P_SuperReady(p) and p.charability ~= CA_NONE and p.pflags & PF_THOKKED and p.cmd.buttons & BT_USE and not p.powers[pw_super] then
			p.powers[pw_super] = 1
			P_PlayJingle(p, JT_SUPER)
			S_StartSound(nil, sfx_supert)
			S_StartSound(nil, sfx_rethok)
		end
	end
end)
addHook("PlayerThink", function(p)
	-- If the values for UrMom-Entum don't exist, create them
	if not p.urmom then
		p.urmom = {
			paintime = 0,
			airtime = 0,
			afterimage = 0,
			jump = false,
			jumptap = false,
			spin = false,
			spintap = false,
			groundtwincooldown = 0,
			lastdash = 0,
			thokbounce = 0,
			justjumped = false,
			startjump = false,
			lowgrav = 0,
			jelly = {
				fallspeed = 0,
				bmomx = 0,
				bmomy = 0,
				bmomz = 0,
				scalex = FRACUNIT,
				scaley = FRACUNIT,
				smomx = 0,
				smomy = 0,
			},
			supertime = 0,
			-- Hyper transformation stuff, except it doesn't exist
			-- Might actually work on it some time later, idfk
			-- hyper = {
			-- 	capable = false,
			-- 	transform = 0,
			-- 	tics = 0,
			-- }
		}
	end
	if not p.mo then return end

	-- Reset mess
	p.urmom.jumptap = false
	p.urmom.spintap = false
	p.urmom.lastdash = $ + 1
	p.urmom.justjumped = false

	-- Yet another mess
	if p.pflags & PF_STARTJUMP and not p.urmom.startjump then 
		p.urmom.justjumped = true
		p.urmom.startjump = true
	end
	if P_IsObjectOnGround(p.mo) then
		p.urmom.startjump = false
	end
	if p.cmd.buttons & BT_JUMP and not p.urmom.jump then
		p.urmom.jump = true
		p.urmom.jumptap = true
	end
	if not (p.cmd.buttons & BT_JUMP) and p.urmom.jump then
		p.urmom.jump = false
	end

	if p.cmd.buttons & BT_USE and not p.urmom.spin then
		p.urmom.spin = true
		p.urmom.spintap = true
	end
	if not (p.cmd.buttons & BT_USE) and p.urmom.spin then
		p.urmom.spin = false
	end
	
	-- Increase paintime by 1 when the player is in the pain state
	-- Reset it if the player is no longer in the pain state
	if P_PlayerInPain(p) then
		if p.urmom.paintime == 0 and unfunny then
			if P_RandomChance(FRACUNIT/16) then
				S_StartSound(p.mo, sfx_vboom)
			end
		end
		p.urmom.paintime = $ + 1
	else
		p.urmom.paintime = 0
	end

	if p.urmom.lowgrav then
		p.urmom.lowgrav = $ - 1
		local gravmul = 1
		if p.mo.eflags & MFE_VERTICALFLIP then gravmul = -1 end
		if ((gravmul == 1 and p.mo.momz < 0) or (gravmul == -1 and p.mo.momz > 0)) then
			p.mo.momz = $ - p.mo.momz/8
		end
	end

	-- Temporary after images effect, used by the recovery jump and bouncing off of a wall as amy
	if p.urmom.afterimage then
		p.urmom.afterimage = $ - 1
		if leveltime % 2 == 0 then
			local g = P_SpawnGhostMobj(p.mo)
			g.blendmode = AST_ADD
			g.colorized = true
		end
	end

	-- Holy shit super transformation emeralds real??////
	if p.powers[pw_super] and p.urmom.supertime == 0 and not UM_SkinInfo(p.mo.skin).notransformanim then
		local gravmul = 1
		if p.mo.eflags & MFE_VERTICALFLIP then gravmul = 2 end
		local mo = P_SpawnMobjFromMobj(p.mo, 0, 0, p.height/2 * gravmul, MT_EMERALDSPIN)
		mo.target = p.mo
		mo.spawnscale = p.mo.scale
	end

	if not p.powers[pw_super] and p.urmom.supertime then
		local emeralds = {
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD1),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD2),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD3),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD4),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD5),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD6),
			P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_EMERALD7)
		}
		local i = 0
		local step = FRACUNIT*360 / #emeralds
		local speed = p.mo.scale * 7
		-- Tactical emerald yeeting
		for _,v in pairs(emeralds) do
			v.flags = ($ | MF_NOCLIPTHING | MF_NOCLIP | MF_NOCLIPHEIGHT) & ~MF_NOGRAVITY
			P_InstaThrust(v, FixedAngle(step * i), speed)
			P_SpawnMobjFromMobj(v, 0, 0, 0, MT_SUPERSPARK)
			v.fuse = 100
			if v.eflags & MFE_VERTICALFLIP then
				v.momz = -v.scale*7
			else
				v.momz = v.scale*7
			end
			v.momx = $ + p.mo.momx
			v.momy = $ + p.mo.momy
			v.momz = $ + p.mo.momz
			i = $ + 1
		end
	end

	if p.powers[pw_super] then
		if p.urmom.supertime < TICRATE and p.mo.state <= S_PLAY_SUPER_TRANS6 and p.mo.state >= S_PLAY_SUPER_TRANS2 then
			p.mo.tics = 2
		end
		p.urmom.supertime = $ + 1
	else
		p.urmom.supertime = 0
	end
	
	-- Landing effect, and jump/spring effect i guess
	if ((P_IsObjectOnGround(p.mo) and p.urmom.airtime) or p.urmom.justjumped or p.powers[pw_justsprung] == 1) and p.mo.health then
		UM_SpawnLand(p.mo)
		if P_IsObjectOnGround(p.mo) then 
			if chaos and unfunny then
				S_StartSound(p.mo, sfx_vboom)
			end
		end
	end

	-- Mid-air and on ground stuff
	if not P_IsObjectOnGround(p.mo) then
		p.urmom.airtime = $ + 1
		if p.urmom.airtime == 7 and not (p.pflags & PF_JUMPED) then
			local g = P_SpawnGhostMobj(p.mo)
		end
	else
		p.urmom.airtime = 0
		p.urmom.thokbounce = 2
		p.thrustfactor = UM_DefaultThrustFactor(p)
	end

	-- Run dust
	if p.speed > p.runspeed/16*15 and P_IsObjectOnGround(p.mo) and not UM_SkinInfo(p.mo.skin).norundust then
		local interval = max(min(10 - (p.speed/FRACUNIT/4), 20), 1)
		if leveltime % interval == 0 then
			P_SpawnSkidDust(p, p.mo.radius)
		end
	end

	-- This has to go, didn't actually like how it looks
	-- if p.speed > FixedMul(p.normalspeed, p.mo.scale)/4*5 and leveltime % 2 == 0 then
	-- 	local g = P_SpawnGhostMobj(p.mo)
	-- 	g.blendmode = AST_ADD
	-- 	g.colorized = true
	-- end

	-- Add the PF_JUMPED flag and remove PF_THOKKED when in the spring state
	if (p.mo.state == S_PLAY_SPRING)
	and not (p.pflags & PF_JUMPED) then
		p.pflags = (p.pflags | PF_JUMPED) & ~PF_THOKKED
	end
	-- Prevent it from running if the player is dead or in pain, because reasons
	if p.mo.health <= 0 or P_PlayerInPain(p) then return end

	-- Speed lines
	if speedlines and p.speed > FixedMul(skins[p.mo.skin].normalspeed, p.mo.scale) then
		if leveltime % 2 == 0 then
			local amt = min(1 + ((FixedDiv(p.speed, p.mo.scale) - skins[p.mo.skin].normalspeed) / (skins[p.mo.skin].normalspeed/15)), 5)
			for i=0, amt, 1 do
				if P_RandomChance(FRACUNIT/2) then 
					UM_SpawnSpeedLine(p, FixedMul(P_RandomFixed(), p.height), FixedMul(-FRACUNIT/2-P_RandomFixed()/8*5, skins[p.mo.skin].radius), SKINCOLOR_CLOUDY)
				else 
					UM_SpawnSpeedLine(p, FixedMul(P_RandomFixed(), p.height), FixedMul( FRACUNIT/2+P_RandomFixed()/8*5, skins[p.mo.skin].radius), SKINCOLOR_CLOUDY) 
				end
			end
		end
	end

	if not P_IsObjectOnGround(p.mo) then
		-- Better mid-air control
		-- This breaks in automatic mode, bruh
		-- local accel = FixedMul(p.thrustfactor * (((p.accelstart*FRACUNIT) + p.speed) * p.acceleration) / (FRACUNIT/16*13), p.mo.scale)
		-- if airControl then
		-- 	P_Thrust(p.mo, p.mo.angle, FixedMul(FixedDiv(p.cmd.forwardmove*FRACUNIT, 50*FRACUNIT), accel))
		-- 	P_Thrust(p.mo, p.mo.angle - ANGLE_90, FixedMul(FixedDiv(p.cmd.sidemove*FRACUNIT, 50*FRACUNIT), accel))
		-- end

		-- Higher gravity
		if (((p.mo.momz < 0 and not (p.mo.eflags & MFE_VERTICALFLIP))
		or (p.mo.momz > 0 and (p.mo.eflags & MFE_VERTICALFLIP))))
		and not (p.mo.flags & MF_NOGRAVITY) and highGravity and not (p.mo.eflags & MFE_GOOWATER) then
			local gravmul = 1
			if p.mo.eflags & MFE_VERTICALFLIP then gravmul = -1 end
			p.mo.momz = $ - FixedMul(FixedMul(gravity, p.mo.scale), gravfactor - FRACUNIT) * gravmul
		end

		if airControl then
			p.thrustfactor = FixedMul(UM_DefaultThrustFactor(p)*FRACUNIT, aircontrolfactor)/FRACUNIT
		else
			p.thrustfactor = UM_DefaultThrustFactor(p)
		end
	elseif not (p.pflags & PF_STARTDASH)
		local normal = skins[p.mo.skin].normalspeed
		if p.charflags & SF_DASHMODE then
			normal = skins[p.mo.skin].normalspeed + (p.dashmode - 3*TICRATE)*2
		end
		local inc = FixedMul(FixedDiv(FixedMul(normal, p.mo.scale), p.normalspeed), p.mo.scale)
		if p.powers[pw_super] or p.powers[pw_sneakers] then normal = $/16*14 end
		if p.speed >= FixedMul(normal/16*15, p.mo.scale) then
			if p.normalspeed < FixedMul(FixedMul(normal, maxspeedincfactor), p.mo.scale) then
				p.normalspeed = $ + FixedMul(inc, speedincfactor)
			end
		else
			p.normalspeed = normal
		end
	end
end)

-- Commands
-- Oh god this is really fucking long
COM_AddCommand("um_aircontrol", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		airControl = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		airControl = false
	else
		CONS_Printf(p, "um_aircontrol [on/off] - Toggles whether or not the increased mid-air control is applied. Currently "
		+ (airControl and "enabled") or (not airControl and "disabled"))
	end
end, COM_ADMIN)

COM_AddCommand("um_gravity", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		highGravity = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		highGravity = false
	else
		CONS_Printf(p, "um_gravity [on/off] - Toggles whether or not the increased gravity is applied. Currently "
		+ (highGravity and "enabled") or (not highGravity and "disabled"))
	end
end, COM_ADMIN)
COM_AddCommand("um_unfunny", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		unfunny = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		unfunny = false
	else
		CONS_Printf(p, "um_unfunny [on/off] - Toggles whether or not some sounds will be randomly replaced with meme sounds. Currently "
		+ (unfunny and "enabled") or (not unfunny and "disabled"))
	end
end, COM_LOCAL)
COM_AddCommand("um_gravfactor", function(p, arg)
	if arg then
		local num = tonumber(arg)
		gravfactor = num*FRACUNIT/100
		print("um_gravfactor set to " + num)
	else
		CONS_Printf(p, "um_gravfactor [number] - Changes the gravity factor. Currently " + (gravfactor*100)/FRACUNIT)
	end
end, COM_ADMIN)
COM_AddCommand("um_aircontrolfactor", function(p, arg)
	if arg then
		local num = tonumber(arg)
		aircontrolfactor = num*FRACUNIT/100
		print("um_aircontrolfactor set to " + num)
	else
		CONS_Printf(p, "um_aircontrolfactor [number] - Changes the mid-air control factor. Currently " + (aircontrolfactor*100)/FRACUNIT)
	end
end, COM_ADMIN)

COM_AddCommand("um_speedincfactor", function(p, arg)
	if arg then
		local num = tonumber(arg)
		speedincfactor = num*FRACUNIT/100
		print("um_speedincfactor set to " + num)
	else
		CONS_Printf(p, "um_speedincfactor [number] - Changes the normalspeed boost rate. Currently " + (speedincfactor*100)/FRACUNIT)
	end
end, COM_ADMIN)
COM_AddCommand("um_maxspeedincfactor", function(p, arg)
	if arg then
		local num = tonumber(arg)
		maxspeedincfactor = num*FRACUNIT/100
		print("um_maxspeedincfactor set to " + num)
	else
		CONS_Printf(p, "um_maxspeedincfactor [number] - Changes the maximum normalspeed increase. Currently " + (maxspeedincfactor*100)/FRACUNIT)
	end
end, COM_ADMIN)
COM_AddCommand("um_speedlines", function(p, arg)
	if arg == "yes" or arg == "on" or arg == "1" then
		speedlines = true
	elseif arg == "no" or arg == "off" or arg == "0" then
		speedlines = false
	else
		CONS_Printf(p, "um_speedlines [on/off] - Toggles whether or not (trash looking) speed lines will be spawned when you go above your character's normalspeed. Currently "
		+ (speedlines and "enabled") or (not speedlines and "disabled"))
	end
end, COM_LOCAL)

COM_AddCommand("um_pleasedonotusethiscommanditwillmakeitunplayableandpainful", function(p)
	if not chaos then
		COM_BufInsertText(p, "um_gravfactor 1277951")
		COM_BufInsertText(p, "um_aircontrolfactor 1277951")
	
		COM_BufInsertText(p, "um_speedincfactor 1277951")
		COM_BufInsertText(p, "um_maxspeedincfactor 1277951")
	
		COM_BufInsertText(p, "um_yeet on")
		COM_BufInsertText(p, "um_unfunny on")
	else
		COM_BufInsertText(p, "um_gravfactor 150")
		COM_BufInsertText(p, "um_aircontrolfactor 200")
	
		COM_BufInsertText(p, "um_speedincfactor 7")
		COM_BufInsertText(p, "um_maxspeedincfactor 150")
	
		COM_BufInsertText(p, "um_yeet off")
		COM_BufInsertText(p, "um_unfunny off")
	end
	chaos = not chaos
end, COM_ADMIN)